<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>12. Virtual Environments and Packages &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="The Python Tutorial" href="index.html" />
    <link rel="next" title="13. What Now?" href="whatnow.html" />
    <link rel="prev" title="11. Brief Tour of the Standard Library – Part II" href="stdlib2.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="whatnow.html" title="13. What Now?"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="stdlib2.html" title="11. Brief Tour of the Standard Library – Part II"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">The Python Tutorial</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="virtual-environments-and-packages">
<span id="tut-venv"></span><h1>12. Virtual Environments and Packages<a class="headerlink" href="#virtual-environments-and-packages" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<h2>12.1. Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>Python applications will often use packages and modules that don&#8217;t
come as part of the standard library.  Applications will sometimes
need a specific version of a library, because the application may
require that a particular bug has been fixed or the application may be
written using an obsolete version of the library&#8217;s interface.</p>
<p>This means it may not be possible for one Python installation to meet
the requirements of every application.  If application A needs version
1.0 of a particular module but application B needs version 2.0, then
the requirements are in conflict and installing either version 1.0 or 2.0
will leave one application unable to run.</p>
<p>The solution for this problem is to create a <a class="reference internal" href="../glossary.html#term-virtual-environment"><span class="xref std std-term">virtual
environment</span></a> (often shortened to &#8220;virtualenv&#8221;), a self-contained
directory tree that contains a Python installation for a particular
version of Python, plus a number of additional packages.</p>
<p>Different applications can then use different virtual environments.
To resolve the earlier example of conflicting requirements,
application A can have its own virtual environment with version 1.0
installed while application B has another virtualenv with version 2.0.
If application B requires a library be upgraded to version 3.0, this will
not affect application A&#8217;s environment.</p>
</div>
<div class="section" id="creating-virtual-environments">
<h2>12.2. Creating Virtual Environments<a class="headerlink" href="#creating-virtual-environments" title="Permalink to this headline">¶</a></h2>
<p>The script used to create and manage virtual environments is called
<strong class="program">pyvenv</strong>.  <strong class="program">pyvenv</strong> will usually install the most
recent version of Python that you have available; the script is also
installed with a version number, so if you have multiple versions of
Python on your system you can select a specific Python version by
running <code class="docutils literal"><span class="pre">pyvenv-3.4</span></code> or whichever version you want.</p>
<p>To create a virtualenv, decide upon a directory
where you want to place it and run <strong class="program">pyvenv</strong> with the
directory path:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="n">pyvenv</span> <span class="n">tutorial</span><span class="o">-</span><span class="n">env</span>
</pre></div>
</div>
<p>This will create the <code class="docutils literal"><span class="pre">tutorial-env</span></code> directory if it doesn&#8217;t exist,
and also create directories inside it containing a copy of the Python
interpreter, the standard library, and various supporting files.</p>
<p>Once you&#8217;ve created a virtual environment, you need to
activate it.</p>
<p>On Windows, run:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="n">tutorial</span><span class="o">-</span><span class="n">env</span><span class="o">/</span><span class="n">Scripts</span><span class="o">/</span><span class="n">activate</span>
</pre></div>
</div>
<p>On Unix or MacOS, run:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="n">source</span> <span class="n">tutorial</span><span class="o">-</span><span class="n">env</span><span class="o">/</span><span class="nb">bin</span><span class="o">/</span><span class="n">activate</span>
</pre></div>
</div>
<p>(This script is written for the bash shell.  If you use the
<strong class="program">csh</strong> or <strong class="program">fish</strong> shells, there are alternate
<code class="docutils literal"><span class="pre">activate.csh</span></code> and <code class="docutils literal"><span class="pre">activate.fish</span></code> scripts you should use
instead.)</p>
<p>Activating the virtualenv will change your shell&#8217;s prompt to show what
virtualenv you&#8217;re using, and modify the environment so that running
<code class="docutils literal"><span class="pre">python</span></code> will get you that particular version and installation of
Python.  For example:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="o">-&gt;</span> <span class="n">source</span> <span class="o">~/</span><span class="n">envs</span><span class="o">/</span><span class="n">tutorial</span><span class="o">-</span><span class="n">env</span><span class="o">/</span><span class="nb">bin</span><span class="o">/</span><span class="n">activate</span>
<span class="p">(</span><span class="n">tutorial</span><span class="o">-</span><span class="n">env</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">python</span>
<span class="n">Python</span> <span class="mf">3.4</span><span class="o">.</span><span class="mi">3</span><span class="o">+</span> <span class="p">(</span><span class="mf">3.4</span><span class="p">:</span><span class="n">c7b9645a6f35</span><span class="o">+</span><span class="p">,</span> <span class="n">May</span> <span class="mi">22</span> <span class="mi">2015</span><span class="p">,</span> <span class="mi">09</span><span class="p">:</span><span class="mi">31</span><span class="p">:</span><span class="mi">25</span><span class="p">)</span>
  <span class="o">...</span>
<span class="o">&gt;&gt;&gt;</span> <span class="kn">import</span> <span class="nn">sys</span>
<span class="o">&gt;&gt;&gt;</span> <span class="n">sys</span><span class="o">.</span><span class="n">path</span>
<span class="p">[</span><span class="s">&#39;&#39;</span><span class="p">,</span> <span class="s">&#39;/usr/local/lib/python34.zip&#39;</span><span class="p">,</span> <span class="o">...</span><span class="p">,</span>
<span class="s">&#39;~/envs/tutorial-env/lib/python3.4/site-packages&#39;</span><span class="p">]</span>
<span class="o">&gt;&gt;&gt;</span>
</pre></div>
</div>
</div>
<div class="section" id="managing-packages-with-pip">
<h2>12.3. Managing Packages with pip<a class="headerlink" href="#managing-packages-with-pip" title="Permalink to this headline">¶</a></h2>
<p>Once you&#8217;ve activated a virtual environment, you can install, upgrade,
and remove packages using a program called <strong class="program">pip</strong>.  By default
<code class="docutils literal"><span class="pre">pip</span></code> will install packages from the Python Package Index,
&lt;<a class="reference external" href="https://pypi.python.org/pypi">https://pypi.python.org/pypi</a>&gt;.  You can browse the Python Package Index
by going to it in your web browser, or you can use <code class="docutils literal"><span class="pre">pip</span></code>&#8216;s
limited search feature:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="p">(</span><span class="n">tutorial</span><span class="o">-</span><span class="n">env</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">pip</span> <span class="n">search</span> <span class="n">astronomy</span>
<span class="n">skyfield</span>               <span class="o">-</span> <span class="n">Elegant</span> <span class="n">astronomy</span> <span class="k">for</span> <span class="n">Python</span>
<span class="n">gary</span>                   <span class="o">-</span> <span class="n">Galactic</span> <span class="n">astronomy</span> <span class="ow">and</span> <span class="n">gravitational</span> <span class="n">dynamics</span><span class="o">.</span>
<span class="n">novas</span>                  <span class="o">-</span> <span class="n">The</span> <span class="n">United</span> <span class="n">States</span> <span class="n">Naval</span> <span class="n">Observatory</span> <span class="n">NOVAS</span> <span class="n">astronomy</span> <span class="n">library</span>
<span class="n">astroobs</span>               <span class="o">-</span> <span class="n">Provides</span> <span class="n">astronomy</span> <span class="n">ephemeris</span> <span class="n">to</span> <span class="n">plan</span> <span class="n">telescope</span> <span class="n">observations</span>
<span class="n">PyAstronomy</span>            <span class="o">-</span> <span class="n">A</span> <span class="n">collection</span> <span class="n">of</span> <span class="n">astronomy</span> <span class="n">related</span> <span class="n">tools</span> <span class="k">for</span> <span class="n">Python</span><span class="o">.</span>
<span class="o">...</span>
</pre></div>
</div>
<p><code class="docutils literal"><span class="pre">pip</span></code> has a number of subcommands: &#8220;search&#8221;, &#8220;install&#8221;, &#8220;uninstall&#8221;,
&#8220;freeze&#8221;, etc.  (Consult the <a class="reference internal" href="../installing/index.html#installing-index"><span>Installing Python Modules</span></a> guide for
complete documentation for <code class="docutils literal"><span class="pre">pip</span></code>.)</p>
<p>You can install the latest version of a package by specifying a package&#8217;s name:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="o">-&gt;</span> <span class="n">pip</span> <span class="n">install</span> <span class="n">novas</span>
<span class="n">Collecting</span> <span class="n">novas</span>
  <span class="n">Downloading</span> <span class="n">novas</span><span class="o">-</span><span class="mf">3.1</span><span class="o">.</span><span class="mf">1.3</span><span class="o">.</span><span class="n">tar</span><span class="o">.</span><span class="n">gz</span> <span class="p">(</span><span class="mi">136</span><span class="n">kB</span><span class="p">)</span>
<span class="n">Installing</span> <span class="n">collected</span> <span class="n">packages</span><span class="p">:</span> <span class="n">novas</span>
  <span class="n">Running</span> <span class="n">setup</span><span class="o">.</span><span class="n">py</span> <span class="n">install</span> <span class="k">for</span> <span class="n">novas</span>
<span class="n">Successfully</span> <span class="n">installed</span> <span class="n">novas</span><span class="o">-</span><span class="mf">3.1</span><span class="o">.</span><span class="mf">1.3</span>
</pre></div>
</div>
<p>You can also install a specific version of a package by giving the
package name  followed by <code class="docutils literal"><span class="pre">==</span></code> and the version number:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="o">-&gt;</span> <span class="n">pip</span> <span class="n">install</span> <span class="n">requests</span><span class="o">==</span><span class="mf">2.6</span><span class="o">.</span><span class="mi">0</span>
<span class="n">Collecting</span> <span class="n">requests</span><span class="o">==</span><span class="mf">2.6</span><span class="o">.</span><span class="mi">0</span>
  <span class="n">Using</span> <span class="n">cached</span> <span class="n">requests</span><span class="o">-</span><span class="mf">2.6</span><span class="o">.</span><span class="mi">0</span><span class="o">-</span><span class="n">py2</span><span class="o">.</span><span class="n">py3</span><span class="o">-</span><span class="n">none</span><span class="o">-</span><span class="nb">any</span><span class="o">.</span><span class="n">whl</span>
<span class="n">Installing</span> <span class="n">collected</span> <span class="n">packages</span><span class="p">:</span> <span class="n">requests</span>
<span class="n">Successfully</span> <span class="n">installed</span> <span class="n">requests</span><span class="o">-</span><span class="mf">2.6</span><span class="o">.</span><span class="mi">0</span>
</pre></div>
</div>
<p>If you re-run this command, <code class="docutils literal"><span class="pre">pip</span></code> will notice that the requested
version is already installed and do nothing.  You can supply a
different version number to get that version, or you can run <code class="docutils literal"><span class="pre">pip</span>
<span class="pre">install</span> <span class="pre">--upgrade</span></code> to upgrade the package to the latest version:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="o">-&gt;</span> <span class="n">pip</span> <span class="n">install</span> <span class="o">--</span><span class="n">upgrade</span> <span class="n">requests</span>
<span class="n">Collecting</span> <span class="n">requests</span>
<span class="n">Installing</span> <span class="n">collected</span> <span class="n">packages</span><span class="p">:</span> <span class="n">requests</span>
  <span class="n">Found</span> <span class="n">existing</span> <span class="n">installation</span><span class="p">:</span> <span class="n">requests</span> <span class="mf">2.6</span><span class="o">.</span><span class="mi">0</span>
    <span class="n">Uninstalling</span> <span class="n">requests</span><span class="o">-</span><span class="mf">2.6</span><span class="o">.</span><span class="mi">0</span><span class="p">:</span>
      <span class="n">Successfully</span> <span class="n">uninstalled</span> <span class="n">requests</span><span class="o">-</span><span class="mf">2.6</span><span class="o">.</span><span class="mi">0</span>
<span class="n">Successfully</span> <span class="n">installed</span> <span class="n">requests</span><span class="o">-</span><span class="mf">2.7</span><span class="o">.</span><span class="mi">0</span>
</pre></div>
</div>
<p><code class="docutils literal"><span class="pre">pip</span> <span class="pre">uninstall</span></code> followed by one or more package names will remove the
packages from the virtual environment.</p>
<p><code class="docutils literal"><span class="pre">pip</span> <span class="pre">show</span></code> will display information about a particular package:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="p">(</span><span class="n">tutorial</span><span class="o">-</span><span class="n">env</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">pip</span> <span class="n">show</span> <span class="n">requests</span>
<span class="o">---</span>
<span class="n">Metadata</span><span class="o">-</span><span class="n">Version</span><span class="p">:</span> <span class="mf">2.0</span>
<span class="n">Name</span><span class="p">:</span> <span class="n">requests</span>
<span class="n">Version</span><span class="p">:</span> <span class="mf">2.7</span><span class="o">.</span><span class="mi">0</span>
<span class="n">Summary</span><span class="p">:</span> <span class="n">Python</span> <span class="n">HTTP</span> <span class="k">for</span> <span class="n">Humans</span><span class="o">.</span>
<span class="n">Home</span><span class="o">-</span><span class="n">page</span><span class="p">:</span> <span class="n">http</span><span class="p">:</span><span class="o">//</span><span class="n">python</span><span class="o">-</span><span class="n">requests</span><span class="o">.</span><span class="n">org</span>
<span class="n">Author</span><span class="p">:</span> <span class="n">Kenneth</span> <span class="n">Reitz</span>
<span class="n">Author</span><span class="o">-</span><span class="n">email</span><span class="p">:</span> <span class="n">me</span><span class="nd">@kennethreitz</span><span class="o">.</span><span class="n">com</span>
<span class="n">License</span><span class="p">:</span> <span class="n">Apache</span> <span class="mf">2.0</span>
<span class="n">Location</span><span class="p">:</span> <span class="o">/</span><span class="n">Users</span><span class="o">/</span><span class="n">akuchling</span><span class="o">/</span><span class="n">envs</span><span class="o">/</span><span class="n">tutorial</span><span class="o">-</span><span class="n">env</span><span class="o">/</span><span class="n">lib</span><span class="o">/</span><span class="n">python3</span><span class="o">.</span><span class="mi">4</span><span class="o">/</span><span class="n">site</span><span class="o">-</span><span class="n">packages</span>
<span class="n">Requires</span><span class="p">:</span>
</pre></div>
</div>
<p><code class="docutils literal"><span class="pre">pip</span> <span class="pre">list</span></code> will display all of the packages installed in the virtual
environment:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="p">(</span><span class="n">tutorial</span><span class="o">-</span><span class="n">env</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">pip</span> <span class="nb">list</span>
<span class="n">novas</span> <span class="p">(</span><span class="mf">3.1</span><span class="o">.</span><span class="mf">1.3</span><span class="p">)</span>
<span class="n">numpy</span> <span class="p">(</span><span class="mf">1.9</span><span class="o">.</span><span class="mi">2</span><span class="p">)</span>
<span class="n">pip</span> <span class="p">(</span><span class="mf">7.0</span><span class="o">.</span><span class="mi">3</span><span class="p">)</span>
<span class="n">requests</span> <span class="p">(</span><span class="mf">2.7</span><span class="o">.</span><span class="mi">0</span><span class="p">)</span>
<span class="n">setuptools</span> <span class="p">(</span><span class="mf">16.0</span><span class="p">)</span>
</pre></div>
</div>
<p><code class="docutils literal"><span class="pre">pip</span> <span class="pre">freeze</span></code> will produce a similar list of the installed packages,
but the output uses the format that <code class="docutils literal"><span class="pre">pip</span> <span class="pre">install</span></code> expects.
A common convention is to put this list in a <code class="docutils literal"><span class="pre">requirements.txt</span></code> file:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="p">(</span><span class="n">tutorial</span><span class="o">-</span><span class="n">env</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">pip</span> <span class="n">freeze</span> <span class="o">&gt;</span> <span class="n">requirements</span><span class="o">.</span><span class="n">txt</span>
<span class="p">(</span><span class="n">tutorial</span><span class="o">-</span><span class="n">env</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">cat</span> <span class="n">requirements</span><span class="o">.</span><span class="n">txt</span>
<span class="n">novas</span><span class="o">==</span><span class="mf">3.1</span><span class="o">.</span><span class="mf">1.3</span>
<span class="n">numpy</span><span class="o">==</span><span class="mf">1.9</span><span class="o">.</span><span class="mi">2</span>
<span class="n">requests</span><span class="o">==</span><span class="mf">2.7</span><span class="o">.</span><span class="mi">0</span>
</pre></div>
</div>
<p>The <code class="docutils literal"><span class="pre">requirements.txt</span></code> can then be committed to version control and
shipped as part of an application.  Users can then install all the
necessary packages with <code class="docutils literal"><span class="pre">install</span> <span class="pre">-r</span></code>:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="o">-&gt;</span> <span class="n">pip</span> <span class="n">install</span> <span class="o">-</span><span class="n">r</span> <span class="n">requirements</span><span class="o">.</span><span class="n">txt</span>
<span class="n">Collecting</span> <span class="n">novas</span><span class="o">==</span><span class="mf">3.1</span><span class="o">.</span><span class="mf">1.3</span> <span class="p">(</span><span class="kn">from</span> <span class="o">-</span><span class="n">r</span> <span class="n">requirements</span><span class="o">.</span><span class="n">txt</span> <span class="p">(</span><span class="n">line</span> <span class="mi">1</span><span class="p">))</span>
  <span class="o">...</span>
<span class="n">Collecting</span> <span class="n">numpy</span><span class="o">==</span><span class="mf">1.9</span><span class="o">.</span><span class="mi">2</span> <span class="p">(</span><span class="kn">from</span> <span class="o">-</span><span class="n">r</span> <span class="n">requirements</span><span class="o">.</span><span class="n">txt</span> <span class="p">(</span><span class="n">line</span> <span class="mi">2</span><span class="p">))</span>
  <span class="o">...</span>
<span class="n">Collecting</span> <span class="n">requests</span><span class="o">==</span><span class="mf">2.7</span><span class="o">.</span><span class="mi">0</span> <span class="p">(</span><span class="kn">from</span> <span class="o">-</span><span class="n">r</span> <span class="n">requirements</span><span class="o">.</span><span class="n">txt</span> <span class="p">(</span><span class="n">line</span> <span class="mi">3</span><span class="p">))</span>
  <span class="o">...</span>
<span class="n">Installing</span> <span class="n">collected</span> <span class="n">packages</span><span class="p">:</span> <span class="n">novas</span><span class="p">,</span> <span class="n">numpy</span><span class="p">,</span> <span class="n">requests</span>
  <span class="n">Running</span> <span class="n">setup</span><span class="o">.</span><span class="n">py</span> <span class="n">install</span> <span class="k">for</span> <span class="n">novas</span>
<span class="n">Successfully</span> <span class="n">installed</span> <span class="n">novas</span><span class="o">-</span><span class="mf">3.1</span><span class="o">.</span><span class="mf">1.3</span> <span class="n">numpy</span><span class="o">-</span><span class="mf">1.9</span><span class="o">.</span><span class="mi">2</span> <span class="n">requests</span><span class="o">-</span><span class="mf">2.7</span><span class="o">.</span><span class="mi">0</span>
</pre></div>
</div>
<p><code class="docutils literal"><span class="pre">pip</span></code> has many more options.  Consult the <a class="reference internal" href="../installing/index.html#installing-index"><span>Installing Python Modules</span></a>
guide for complete documentation for <code class="docutils literal"><span class="pre">pip</span></code>.  When you&#8217;ve written
a package and want to make it available on the Python Package Index,
consult the <a class="reference internal" href="../distributing/index.html#distributing-index"><span>Distributing Python Modules</span></a> guide.</p>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">12. Virtual Environments and Packages</a><ul>
<li><a class="reference internal" href="#introduction">12.1. Introduction</a></li>
<li><a class="reference internal" href="#creating-virtual-environments">12.2. Creating Virtual Environments</a></li>
<li><a class="reference internal" href="#managing-packages-with-pip">12.3. Managing Packages with pip</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="stdlib2.html"
                        title="previous chapter">11. Brief Tour of the Standard Library &#8211; Part II</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="whatnow.html"
                        title="next chapter">13. What Now?</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/tutorial/venv.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="whatnow.html" title="13. What Now?"
             >next</a> |</li>
        <li class="right" >
          <a href="stdlib2.html" title="11. Brief Tour of the Standard Library – Part II"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Tutorial</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>